---
title: Element.getAttributeNS()
slug: Web/API/Element/getAttributeNS
tags:
  - API
  - DOM
  - Element
  - Method
  - Reference
---
<div>{{APIRef("DOM")}}</div>

<p>The <strong><code>getAttributeNS()</code></strong> method of the {{domxref("Element")}} interface returns the string value of the attribute with the specified namespace and name. If the named attribute does not exist, the value returned will either be <code>null</code> or <code>""</code> (the empty string); see {{Anch("Notes")}} for details.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>attrVal</em> = <em>element</em>.getAttributeNS(<em>namespace</em>, <em>name</em>)
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>namespace</code></dt>
 <dd>The namespace in which to look for the specified attribute.</dd>
 <dt><code>name</code></dt>
 <dd>The name of the attribute to look for.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>The string value of the specified attribute. If the attribute doesn't exist, the result is <code>null</code>.</p>

<div class="note"><strong>Note:</strong> Earlier versions of the DOM specification had this method described as returning an empty string for non-existent attributes, but it was not typically implemented this way since null makes more sense. The DOM4 specification now says this method should return null for non-existent attributes.</div>

<h2 id="Examples">Examples</h2>

<p>The following SVG document reads the value of the <code>foo</code> attribute in a custom namespace.</p>

<pre class="brush: xml">&lt;svg xmlns="http://www.w3.org/2000/svg"
    xmlns:test="http://www.example.com/2014/test" width="40" height="40"&gt;

  &lt;circle id="target" cx="12" cy="12" r="10" stroke="#444"
      stroke-width="2" fill="none" test:foo="Hello namespaced attribute!"/&gt;

  &lt;script type="text/javascript"&gt;
    var ns = 'http://www.example.com/2014/test';
    var circle = document.getElementById( 'target' );

    console.log( 'attribute test:foo: "' + circle.getAttributeNS( ns, 'foo' ) + '"' );
  &lt;/script&gt;
&lt;/svg&gt;
</pre>

<p>In an HTML5 document the attribute has to be accessed with <code>test:foo</code> since namespaces are not supported.</p>

<pre class="brush: html">&lt;!DOCTYPE html&gt;
&lt;html&gt;
&lt;body&gt;

&lt;svg xmlns="http://www.w3.org/2000/svg"
    xmlns:test="http://www.example.com/2014/test" width="40" height="40"&gt;
  &lt;circle id="target" cx="12" cy="12" r="10" stroke="#444" stroke-width="2"
      fill="none" test:foo="Foo value"/&gt;
&lt;/svg&gt;

&lt;script type="text/javascript"&gt;
  var ns = 'http://www.example.com/2014/test';
  var circle = document.getElementById( 'target' );
  console.log('Attribute value: ' + circle.getAttribute('test:foo'));
&lt;/script&gt;

&lt;/body&gt;
&lt;/html&gt;</pre>

<h2 id="Notes">Notes</h2>

<p>Namespaces are only supported in XML documents. HTML5 documents have to use <code>getAttribute()</code> instead.</p>

<p><code>getAttributeNS()</code> differs from {{domxref("element.getAttribute()", "getAttribute()")}} in that it allows you to further specify the requested attribute as being part of a particular namespace, as in the example above, where the attribute is part of the fictional "specialspace" namespace on Mozilla.</p>

<p>Prior to the DOM4 specification, this method was specified to return an empty string rather than null for non-existent attributes. However, most browsers instead returned null. Starting with DOM4, the specification now says to return null. However, some older browsers return an empty string. For that reason, you should use {{domxref("element.hasAttributeNS()", "hasAttributeNS()")}} to check for an attribute's existence prior to calling <code>getAttributeNS()</code> if it is possible that the requested attribute does not exist on the specified element.</p>

<p>{{DOMAttributeMethods}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("DOM WHATWG", "#dom-element-getattributens", "Element.getAttributeNS()")}}</td>
   <td>{{Spec2("DOM WHATWG")}}</td>
   <td> </td>
  </tr>
  <tr>
   <td>{{SpecName("DOM3 Core", "#ID-ElGetAttrNS", "Element.getAttributeNS()")}}</td>
   <td>{{Spec2("DOM3 Core")}}</td>
   <td>Specifies that a <code>NOT_SUPPORTED_ERR</code> exception is thrown if the UA does not support the <code>"XML"</code> feature. Also specifies that <code>null</code> must be passed to have no namespace.</td>
  </tr>
  <tr>
   <td>{{SpecName("DOM2 Core", "#ID-ElGetAttrNS", "Element.getAttributeNS()")}}</td>
   <td>{{Spec2("DOM2 Core")}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Element.getAttributeNS")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/Add-ons/Code_snippets/getAttributeNS">Code snippets:getAttributeNS</a></li>
</ul>
